# This file is autogenerated
import threading
import ctypes
import os
from .autd3capi_def import LinkPtr


class Singleton(type):
    _instances = {}  # type: ignore
    _lock = threading.Lock()

    def __call__(cls, *args, **kwargs):
        if cls not in cls._instances:
            with cls._lock:
                if cls not in cls._instances:
                    cls._instances[cls] = super(Singleton, cls).__call__(*args, **kwargs)
        return cls._instances[cls]


class NativeMethods(metaclass=Singleton):

    def init_dll(self, bin_location: str, bin_prefix: str, bin_ext: str):
        try:
            self.dll = ctypes.CDLL(os.path.join(bin_location, f'{bin_prefix}autd3capi_link_twincat{bin_ext}'))
        except Exception:
            return

        self.dll.AUTDLinkTwinCAT.argtypes = [ctypes.c_char_p] 
        self.dll.AUTDLinkTwinCAT.restype = LinkPtr

        self.dll.AUTDLinkTwinCATTimeout.argtypes = [LinkPtr, ctypes.c_uint64]  # type: ignore 
        self.dll.AUTDLinkTwinCATTimeout.restype = LinkPtr

        self.dll.AUTDLinkRemoteTwinCAT.argtypes = [ctypes.c_char_p, ctypes.c_char_p] 
        self.dll.AUTDLinkRemoteTwinCAT.restype = LinkPtr

        self.dll.AUTDLinkRemoteTwinCATServerIP.argtypes = [LinkPtr, ctypes.c_char_p]  # type: ignore 
        self.dll.AUTDLinkRemoteTwinCATServerIP.restype = LinkPtr

        self.dll.AUTDLinkRemoteTwinCATClientAmsNetId.argtypes = [LinkPtr, ctypes.c_char_p]  # type: ignore 
        self.dll.AUTDLinkRemoteTwinCATClientAmsNetId.restype = LinkPtr

        self.dll.AUTDLinkRemoteTwinCATTimeout.argtypes = [LinkPtr, ctypes.c_uint64]  # type: ignore 
        self.dll.AUTDLinkRemoteTwinCATTimeout.restype = LinkPtr

    def link_twin_cat(self, err: ctypes.Array[ctypes.c_char]) -> LinkPtr:
        return self.dll.AUTDLinkTwinCAT(err)

    def link_twin_cat_timeout(self, twincat: LinkPtr, timeout_ns: int) -> LinkPtr:
        return self.dll.AUTDLinkTwinCATTimeout(twincat, timeout_ns)

    def link_remote_twin_cat(self, server_ams_net_id: bytes, err: ctypes.Array[ctypes.c_char]) -> LinkPtr:
        return self.dll.AUTDLinkRemoteTwinCAT(server_ams_net_id, err)

    def link_remote_twin_cat_server_ip(self, twincat: LinkPtr, addr: bytes) -> LinkPtr:
        return self.dll.AUTDLinkRemoteTwinCATServerIP(twincat, addr)

    def link_remote_twin_cat_client_ams_net_id(self, twincat: LinkPtr, id: bytes) -> LinkPtr:
        return self.dll.AUTDLinkRemoteTwinCATClientAmsNetId(twincat, id)

    def link_remote_twin_cat_timeout(self, twincat: LinkPtr, timeout_ns: int) -> LinkPtr:
        return self.dll.AUTDLinkRemoteTwinCATTimeout(twincat, timeout_ns)
